--PERSISTENT
HiyoDText = {};
HiyoMText = {};
HiyoSelectedBridle = ALL;
HiyoCooldown = "300";
HiyoTimeSinceLastUpdate = 2;
HiyoWasUnmounted = true;
lastTimeHiyo = time()-10000; -- force hiyoing on the first update;
HiyoLastBridleUsed = "";
HiyoDebug = false;

function HiyoSilver_OnUpdate(elapsed)
	HiyoTimeSinceLastUpdate = HiyoTimeSinceLastUpdate + elapsed; 	
	if HiyoTimeSinceLastUpdate > 1 then -- fire every 1 second
		if (IsMounted()) and (HiyoWasUnmounted) and (not UnitOnTaxi("player")) then
			--User mounted since last update.
			HiyoWasUnmounted = false;
			HiyoLastBridleUsed = HiyoSilver_GetLastBridleUsed();
			if time() >= (lastTimeHiyo + HiyoCooldown) then
				HiyoSaySomething(HiyoMText);
			end
		elseif (not IsMounted()) and (not HiyoWasUnmounted) and (not UnitOnTaxi("player"))  then
			--User dismounted since last update
			HiyoWasUnmounted = true;
			if time() >= (lastTimeHiyo + HiyoCooldown) then
				HiyoSaySomething(HiyoDText);
			end
		end --Other combinations are meaningless to this application.
		HiyoTimeSinceLastUpdate = 0;
	end
end

function HiyoSaySomething(theTable)
	local combinedTable = {};
	local combinedString="";
	local p;
	local tC;
	if (HiyoLastBridleUsed == nil) or (HiyoLastBridleUsed == "") then
		HiyoLastBridleUsed = ALL;
	end
	if theTable[ALL] == nil then
		theTable[ALL] = "";
	end
	if theTable[HiyoLastBridleUsed] == nil then
		 theTable[HiyoLastBridleUsed] = "";
	end
	--Do we have any entries at all?
	if theTable[ALL] == "" then
		combinedString = theTable[HiyoLastBridleUsed];
	else
		if theTable[HiyoLastBridleUsed] == "" then
			combinedString = theTable[ALL];
		else
			combinedString = theTable[ALL] .. "\n" .. theTable[HiyoLastBridleUsed];
		end
	end
	if combinedString ~= "" then
		combinedTable = {strsplit("\n", combinedString)};
		p = random(1, getn(combinedTable));
		local sayMe = combinedTable[p];
		--If not a blank, say something
		if sayMe ~= "" then
			-- Split on tildes
			local sayTable = {strsplit("~", sayMe)};
			if sayTable == nil then
				tinsert(sayTable, sayMe);
			end
			for ix, sM in pairs(sayTable) do
				--Decide upon chat channel
				if strsub(sM, 1, 1) == "/" then
					local a = strfind(sM, " ");
					if a then
						tC = strlower(strsub(sM, 1, a-1));
						sM = strsub(sM, a+1, strlen(sM));
					else -- no spaces, just say everything but the slash
						sM = strsub(sM, 2, strlen(sM));
					end
				else
					tC = SLASH_SAY1;
				end
				if (tC == SLASH_EMOTE1) or  (tC == SLASH_EMOTE2) or (tC == SLASH_EMOTE3) or (tC == SLASH_EMOTE4) or (tC == SLASH_EMOTE5) or (tC == SLASH_EMOTE6) or (tC == SLASH_EMOTE7) or (tC == SLASH_EMOTE8) then
					tC = "EMOTE";
				elseif (tC == SLASH_YELL1) or  (tC == SLASH_YELL2) or (tC == SLASH_YELL3) or (tC == SLASH_YELL4) or (tC == SLASH_YELL5) or (tC == SLASH_YELL6) or (tC == SLASH_YELL7) or (tC == SLASH_YELL8)  then
					tC = "YELL";
				else
					tC = "SAY";
				end

				-- Handle special emotes
				local eM = strlower("/"..sM);
-- Most common ones first
				if (eM == strlower(EMOTE105_CMD1)) or (eM == strlower(EMOTE105_CMD2))  then
					tC = "WHISTLE"; -- You let out a sharp whistle.
				elseif (eM == strlower(EMOTE148_CMD1)) or (eM == strlower(EMOTE148_CMD2))  then
					tC = "BARK"; -- You bark. Woof! Woof!
				elseif (eM == strlower(EMOTE147_CMD1)) or (eM == strlower(EMOTE147_CMD2))  then
					tC = "GROWL"; -- You growl menacingly.
				elseif (eM == strlower(EMOTE124_CMD1)) or (eM == strlower(EMOTE124_CMD2))  then
					tC = "PURR"; -- You purr like a kitten.
				elseif (eM == strlower(EMOTE76_CMD1)) or (eM == strlower(EMOTE76_CMD2))  then
					tC = "ROAR"; -- You roar with bestial vigor. So fierce! 
				elseif (eM == strlower(EMOTE89_CMD1)) or (eM == strlower(EMOTE89_CMD2))  then
					tC = "SNARL"; -- You bare your teeth and snarl.
				elseif (eM == strlower(EMOTE59_CMD1)) or (eM == strlower(EMOTE59_CMD2)) or (eM == strlower(EMOTE59_CMD3)) or (eM == strlower(EMOTE59_CMD4))  then
					tC = "BLOW"; -- You blow a kiss into the wind.
				elseif (eM == strlower(EMOTE19_CMD1)) or (eM == strlower(EMOTE19_CMD2)) or (eM == strlower(EMOTE19_CMD3)) or (eM == strlower(EMOTE19_CMD4))  then
					tC = "BYE"; -- You wave goodbye to everyone. Farewell!
				elseif (eM == strlower(EMOTE22_CMD1)) or (eM == strlower(EMOTE22_CMD2)) or (eM == strlower(EMOTE22_CMD3)) or (eM == strlower(EMOTE22_CMD4))  then
					tC = "CHICKEN"; -- With arms flapping, you strut around. Cluck, Cluck, Chicken!
				elseif (eM == strlower(EMOTE36_CMD1)) or (eM == strlower(EMOTE36_CMD2)) or (eM == strlower(EMOTE36_CMD3)) or (eM == strlower(EMOTE36_CMD4))  then
					tC = "DRINK"; -- You raise a drink in the air before chugging it down. Cheers!
				elseif (eM == strlower(EMOTE97_CMD1)) or (eM == strlower(EMOTE97_CMD2))  then
					tC = "TAP"; -- You tap your foot. Hurry up already!
				elseif (eM == strlower(EMOTE45_CMD1)) or (eM == strlower(EMOTE45_CMD2))  then
					tC = "GAZE"; -- You gaze off into the distance.
				elseif (eM == strlower(EMOTE71_CMD1)) or (eM == strlower(EMOTE71_CMD2))  then
					tC = "PEER"; -- You peer around, searchingly
				elseif (eM == strlower(EMOTE73_CMD1)) or (eM == strlower(EMOTE73_CMD2))  then
					tC = "POINT"; -- You point over yonder.
				elseif (eM == strlower(EMOTE30_CMD1)) or (eM == strlower(EMOTE30_CMD2)) or (eM == strlower(EMOTE30_CMD3)) or (eM == strlower(EMOTE30_CMD4))  then
					tC = "CRACK"; -- You crack your knuckles.
				elseif (eM == strlower(EMOTE126_CMD1)) or (eM == strlower(EMOTE126_CMD2)) or (eM == strlower(EMOTE126_CMD3)) or (eM == strlower(EMOTE126_CMD4))  then
					tC = "RAISE"; -- Youraise your hand in the air.
				elseif (eM == strlower(EMOTE127_CMD1)) or (eM == strlower(EMOTE127_CMD2)) or (eM == strlower(EMOTE127_CMD3)) or (eM == strlower(EMOTE127_CMD4))  then
					tC = "READY"; -- Youlet everyone know you are ready!
				elseif (eM == strlower(EMOTE133_CMD1)) or (eM == strlower(EMOTE133_CMD2))  then
					tC = "SNIFF"; -- You sniff the air around you.
				elseif (eM == strlower(EMOTE136_CMD1)) or (eM == strlower(EMOTE136_CMD2)) or (eM == strlower(EMOTE136_CMD3)) or (eM == strlower(EMOTE136_CMD4))  then
					tC = "STINK"; -- You smell the air around you. Wow, someone stinks! 
				elseif (eM == strlower(EMOTE90_CMD1)) or (eM == strlower(EMOTE90_CMD2))  then
					tC = "SPIT"; -- You spit on the ground. 
				elseif (eM == strlower(EMOTE18_CMD1)) or (eM == strlower(EMOTE18_CMD2)) or (eM == strlower(EMOTE18_CMD3)) or (eM == strlower(EMOTE18_CMD4))  then
					tC = "BURP"; -- You let out a loud belch.
				elseif (eM == strlower(EMOTE40_CMD1)) or (eM == strlower(EMOTE40_CMD2))  then
					tC = "FART"; -- You fart loudly. Whew, what stinks?
				elseif (eM == strlower(EMOTE100_CMD1)) or (eM == strlower(EMOTE100_CMD2))  then
					tC = "TIRED"; -- You let everyone know that you are tired. 
-- Less common ones, I would think
				elseif (eM == strlower(EMOTE2_CMD1)) or (eM == strlower(EMOTE2_CMD2))  then
					tC = "AMAZE"; -- You are amazed!
				elseif (eM == strlower(EMOTE3_CMD1)) or (eM == strlower(EMOTE3_CMD2)) or (eM == strlower(EMOTE3_CMD3)) or (eM == strlower(EMOTE3_CMD4))  then
					tC = "ANGRY"; -- You shake your fist in anger.
				elseif (eM == strlower(EMOTE5_CMD1)) or (eM == strlower(EMOTE5_CMD2)) or (eM == strlower(EMOTE5_CMD3)) or (eM == strlower(EMOTE5_CMD4))  then
					tC = "APPLAUD"; -- You applaud. Bravo!
				elseif (eM == strlower(EMOTE11_CMD1)) or (eM == strlower(EMOTE11_CMD2))  then
					tC = "BLINK"; -- You blink your eyes.
				elseif (eM == strlower(EMOTE168_CMD1)) or (eM == strlower(EMOTE168_CMD2))  then
					tC = "WINK"; -- You wink slyly.
				elseif (eM == strlower(EMOTE46_CMD1)) or (eM == strlower(EMOTE46_CMD2))  then
					tC = "GIGGLE"; -- You giggle
				elseif (eM == strlower(EMOTE53_CMD1)) or (eM == strlower(EMOTE53_CMD2))  then
					tC = "GUFFAW"; -- You let out a boisterous guffaw!.
				elseif (eM == strlower(EMOTE61_CMD1)) or (eM == strlower(EMOTE61_CMD2)) or (eM == strlower(EMOTE61_CMD3)) or (eM == strlower(EMOTE61_CMD4))  then
					tC = "LAUGH"; -- You laugh.
				elseif (eM == strlower(EMOTE20_CMD1)) or (eM == strlower(EMOTE20_CMD2))  then
					tC = "CACKLE"; -- You cackle maniacally at the situation.
				elseif (eM == strlower(EMOTE23_CMD1)) or (eM == strlower(EMOTE23_CMD2))  then
					tC = "CHUCKLE"; -- You let out a hearty chuckle.
				elseif (eM == strlower(EMOTE145_CMD1)) or (eM == strlower(EMOTE145_CMD2))  then
					tC = "SMILE"; -- You smile.
				elseif (eM == strlower(EMOTE141_CMD1)) or (eM == strlower(EMOTE141_CMD2))  then
					tC = "SNICKER"; -- You quietly snicker to yourself. 
				elseif (eM == strlower(EMOTE85_CMD1)) or (eM == strlower(EMOTE85_CMD2))  then
					tC = "SHY"; -- You smile shyly.
				elseif (eM == strlower(EMOTE132_CMD1)) or (eM == strlower(EMOTE132_CMD2))  then
					tC = "SMIRK"; -- A sly smirk spreads across your face. 
				elseif (eM == strlower(EMOTE86_CMD1)) or (eM == strlower(EMOTE86_CMD2))  then
					tC = "SIGH"; -- You let out a long, drawn-out sigh. 
				elseif (eM == strlower(EMOTE15_CMD1)) or (eM == strlower(EMOTE15_CMD2))  then
					tC = "BOUNCE"; -- You bounce up and down in front of everyone.
				elseif (eM == strlower(EMOTE17_CMD1)) or (eM == strlower(EMOTE17_CMD2))  then
					tC = "BOW"; -- You bow down graciously.
				elseif (eM == strlower(EMOTE80_CMD1)) or (eM == strlower(EMOTE80_CMD2)) or (eM == strlower(EMOTE80_CMD3)) or (eM == strlower(EMOTE80_CMD4))  or (eM == strlower(EMOTE80_CMD5)) or (eM == strlower(EMOTE80_CMD6)) then
					tC = "SCRATCH"; -- You scratch yourself. Ah, much better!
				elseif (eM == strlower(EMOTE21_CMD1)) or (eM == strlower(EMOTE21_CMD2))  then
					tC = "CHEER"; -- You cheer!
				elseif (eM == strlower(EMOTE24_CMD1)) or (eM == strlower(EMOTE24_CMD2))  then
					tC = "CLAP"; -- You clap excitedly.
				elseif (eM == strlower(EMOTE28_CMD1)) or (eM == strlower(EMOTE28_CMD2))  then
					tC = "COUGH"; -- You let out a hacking cough.
				elseif (eM == strlower(EMOTE29_CMD1)) or (eM == strlower(EMOTE29_CMD2)) or (eM == strlower(EMOTE29_CMD3)) or (eM == strlower(EMOTE29_CMD4))  then
					tC = "COWER"; -- You cower in fear.
				elseif (eM == strlower(EMOTE31_CMD1)) or (eM == strlower(EMOTE31_CMD2))  then
					tC = "CRINGE"; -- You cringe in fear.
				elseif (eM == strlower(EMOTE150_CMD1)) or (eM == strlower(EMOTE150_CMD2))  then
					tC = "SCARED"; -- You are scared!
				elseif (eM == strlower(EMOTE32_CMD1)) or (eM == strlower(EMOTE32_CMD2)) or (eM == strlower(EMOTE32_CMD3)) or (eM == strlower(EMOTE32_CMD4))  or (eM == strlower(EMOTE32_CMD5)) or (eM == strlower(EMOTE32_CMD6)) then
					tC = "CRY"; -- You cry.
				elseif (eM == strlower(EMOTE34_CMD1)) or (eM == strlower(EMOTE34_CMD2))  then
					tC = "CURTSEY"; -- You curtsey.
				elseif (eM == strlower(EMOTE35_CMD1)) or (eM == strlower(EMOTE35_CMD2))  then
					tC = "DANCE"; -- You break into dance.
					elseif (eM == strlower(EMOTE43_CMD1)) or (eM == strlower(EMOTE43_CMD2)) or (eM == strlower(EMOTE43_CMD3)) or (eM == strlower(EMOTE43_CMD4))  or (eM == strlower(EMOTE43_CMD5)) or (eM == strlower(EMOTE43_CMD6)) then
					tC = "FROWN"; -- You frown.
				elseif (eM == strlower(EMOTE113_CMD1)) or (eM == strlower(EMOTE113_CMD2))  then
					tC = "DUCK"; -- You duck for cover.
				elseif (eM == strlower(EMOTE39_CMD1)) or (eM == strlower(EMOTE39_CMD2))  then
					tC = "EYE"; -- You cross your eyes.
				elseif (eM == strlower(EMOTE41_CMD1)) or (eM == strlower(EMOTE41_CMD2)) or (eM == strlower(EMOTE41_CMD3)) or (eM == strlower(EMOTE41_CMD4))  then
					tC = "FIDGET"; -- You fidget impatiently.
				elseif (eM == strlower(EMOTE160_CMD1)) or (eM == strlower(EMOTE160_CMD2))  then
					tC = "FLEE"; -- You yell for everyone to flee!
				elseif (eM == strlower(EMOTE151_CMD1)) or (eM == strlower(EMOTE151_CMD2))  then
					tC = "FLOP"; -- You flop around helplessly.
				elseif (eM == strlower(EMOTE79_CMD1)) or (eM == strlower(EMOTE79_CMD2))  then
					tC = "SALUTE"; -- You stand at attention and salute. 
				elseif (eM == strlower(EMOTE44_CMD1)) or (eM == strlower(EMOTE44_CMD2)) or (eM == strlower(EMOTE44_CMD3))  then
					tC = "GASP"; -- You gasp.
				elseif (eM == strlower(EMOTE55_CMD1)) or (eM == strlower(EMOTE55_CMD2)) or (eM == strlower(EMOTE55_CMD3)) or (eM == strlower(EMOTE55_CMD4))  or (eM == strlower(EMOTE55_CMD5)) or (eM == strlower(EMOTE55_CMD6)) then
					tC = "HAPPY"; -- You are filled with happiness!
				elseif (eM == strlower(EMOTE47_CMD1)) or (eM == strlower(EMOTE47_CMD2))  then
					tC = "GLARE"; -- You glare angrily
				elseif (eM == strlower(EMOTE50_CMD1)) or (eM == strlower(EMOTE50_CMD2)) or (eM == strlower(EMOTE50_CMD3)) or (eM == strlower(EMOTE50_CMD4))  or (eM == strlower(EMOTE50_CMD5)) or (eM == strlower(EMOTE50_CMD6)) then
					tC = "GRIN"; -- You grin wickedly.
				elseif (eM == strlower(EMOTE51_CMD1)) or (eM == strlower(EMOTE51_CMD2))  then
					tC = "GROAN"; -- You begin to groan.
				elseif (eM == strlower(EMOTE60_CMD1)) or (eM == strlower(EMOTE60_CMD2)) or (eM == strlower(EMOTE60_CMD3))  then
					tC = "KNEEL"; -- You kneel down.
				elseif (eM == strlower(EMOTE123_CMD1)) or (eM == strlower(EMOTE123_CMD2)) or (eM == strlower(EMOTE123_CMD3)) or (eM == strlower(EMOTE123_CMD4))  then
					tC = "PRAISE"; -- You praise the Light.
				elseif (eM == strlower(EMOTE75_CMD1)) or (eM == strlower(EMOTE75_CMD2))  then
					tC = "PRAY"; -- You ppray to the gods.
				elseif (eM == strlower(EMOTE62_CMD1)) or (eM == strlower(EMOTE62_CMD2)) or (eM == strlower(EMOTE62_CMD3)) or (eM == strlower(EMOTE62_CMD4))  then
					tC = "LAYDOWN"; -- You lay down.
				elseif (eM == strlower(EMOTE118_CMD1)) or (eM == strlower(EMOTE118_CMD2))  then
					tC = "LISTEN"; -- You are listening!
				elseif (eM == strlower(EMOTE153_CMD1)) or (eM == strlower(EMOTE153_CMD2))  then
					tC = "MOO"; -- Moo.
				elseif (eM == strlower(EMOTE68_CMD1)) or (eM == strlower(EMOTE68_CMD2)) or (eM == strlower(EMOTE68_CMD3)) or (eM == strlower(EMOTE68_CMD4))  then
					tC = "NOD"; -- You nod.
				elseif (eM == strlower(EMOTE69_CMD1)) or (eM == strlower(EMOTE69_CMD2)) or (eM == strlower(EMOTE69_CMD3)) or (eM == strlower(EMOTE69_CMD4))  then
					tC = "NOSEPICK"; -- With a finger deep in one nostril, you pass the time.
				elseif (eM == strlower(EMOTE70_CMD1)) or (eM == strlower(EMOTE70_CMD2))  then
					tC = "PANIC"; -- You run around in a frenzied state of panic.
				elseif (eM == strlower(EMOTE92_CMD1)) or (eM == strlower(EMOTE92_CMD2))  then
					tC = "SURPRISED"; -- You are so surprised! 
				elseif (eM == strlower(EMOTE74_CMD1)) or (eM == strlower(EMOTE74_CMD2))  then
					tC = "POKE"; -- You poke your belly and giggle.
				elseif (eM == strlower(EMOTE121_CMD1)) or (eM == strlower(EMOTE121_CMD2))  then
					tC = "PONDER"; -- You ponder the situation.
				elseif (eM == strlower(EMOTE146_CMD1)) or (eM == strlower(EMOTE146_CMD2))  then
					tC = "RASP"; -- You make a rude gesture.
				elseif (eM == strlower(EMOTE78_CMD1)) or (eM == strlower(EMOTE78_CMD2))  then
					tC = "RUDE"; -- You make a rude gesture.
				elseif (eM == strlower(EMOTE10_CMD1)) or (eM == strlower(EMOTE10_CMD2)) or (eM == strlower(EMOTE10_CMD3)) or (eM == strlower(EMOTE10_CMD4))  then
					tC = "BLEED"; -- Blood flows from your wounds.
				elseif (eM == strlower(EMOTE99_CMD1)) or (eM == strlower(EMOTE99_CMD2)) or (eM == strlower(EMOTE99_CMD3)) or (eM == strlower(EMOTE99_CMD4))  or (eM == strlower(EMOTE99_CMD5)) or (eM == strlower(EMOTE99_CMD6)) or (eM == strlower(EMOTE99_CMD7)) or (eM == strlower(EMOTE99_CMD8)) then
					tC = "THREATEN"; -- You threaten everyone with the wrath of doom.
				end
				
				if (tC == "YELL") or (tC == "SAY") or (tC == "EMOTE") then
					SendChatMessage(sM, tC); -- it was an ordinary say, yell, or miscellaneous emote
				else
					DoEmote(tC, "");
				end
			end
		end
		lastTimeHiyo = time();
	end
end

function HiyoSilver_GetBridles()
	local nameTable = {ALL};
	local effectTable = {"-"};
	for bagNumber = -1, 11 do --allow checking of bank slots, otherwise 0 to 4
		local nSlots = GetContainerNumSlots(bagNumber);
		for slotNumber = 1, nSlots do -- if nSlots=0 the loop won't trigger!
			local theItemLink = GetContainerItemLink(bagNumber, slotNumber);
			if (theItemLink ~= nil) then
				local itemName, _, _, _, _, _, _, _, _, itemTexture = GetItemInfo(theItemLink);
				-- Is it a bridle?
				if (string.find(itemTexture, "Ability_Mount_") ~= nil) or (string.find(itemTexture, "Ability_Hunter_") ~= nil)  then
					local temp = {strsplit(":", theItemLink)};
					local tempID = temp[2];
					local itemEffect = GetItemSpell(tempID);
					tinsert(nameTable, itemName);
					tinsert(effectTable, itemEffect);
				end
			end
		end
	end
	return nameTable, effectTable;
end

function HiyoSilver_GetLastBridleUsed()
	local nameTable, effectTable = HiyoSilver_GetBridles();
	local buffName;
	local i = 0;
	repeat
		i = i+1;	
		buffName = UnitBuff("player", i);
		-- Find it in bridle texture list
		for ix, effectName in pairs(effectTable) do
			if buffName == effectName then
				return nameTable[ix];
			end
		end
	until (buffName == nil);
	return "gbroagfran"; -- shouldn't happen
end

--UI WIDGETS

function HiyoSilver_MountSelect_Initialize()
	local nameTable, _ = HiyoSilver_GetBridles();
	local info = UIDropDownMenu_CreateInfo();
	for bridle, bridleName in pairs(nameTable) do
		info.text = bridleName;
		info.value = bridleName;
		info.func = HiyoSilver_MountSelect_OnClick;
		info.owner = HiyoSilver_MountSelect;
		info.checked = nil;
		info.icon = nil;
		UIDropDownMenu_AddButton(info, 1);
	end
	--Show current bridle name
	UIDropDownMenu_SetSelectedValue(HiyoSilver_MountSelect, HiyoSelectedBridle);
	if HiyoMText[HiyoSelectedBridle] == nil then
		HiyoMText[HiyoSelectedBridle] = "";
	end
	HiyoSilver_MountText:SetText(HiyoMText[HiyoSelectedBridle]);
	if HiyoDText[HiyoSelectedBridle] == nil then
		HiyoDText[HiyoSelectedBridle] = "";
	end
	HiyoSilver_DismountText:SetText(HiyoDText[HiyoSelectedBridle]);
end

function HiyoSilver_MountSelect_OnClick()
	HiyoSelectedBridle = this.value;
	HiyoSilver_MountSelect_Initialize();
end

function HiyoSilver_SlashHandler(msg)
	if msg == "debug" then
		HiyoDebug = not HiyoDebug;
		HiyoDebugMsg("Debugging is on.");
	else
		HiyoSilver_Frame:Show();
	end
end

--STARTUP CODE

--Register slash commands
SLASH_HIYOSILVER1 = "/hiyo";
SLASH_HIYOSILVER2 = "/hiyosilver";
SlashCmdList["HIYOSILVER"] = HiyoSilver_SlashHandler;
--Print hello message
if DEFAULT_CHAT_FRAME then
	DEFAULT_CHAT_FRAME:AddMessage(HIYOSILVER_STARTMSG,0,0.8,1);
end

function HiyoDebugMsg(arg)
	if HiyoDebug then
		DEFAULT_CHAT_FRAME:AddMessage(arg);
	end
end